/*
 * This file is a part of the SteamWar software.
 *
 * Copyright (C) 2021  SteamWar.de-Serverteam
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.features.region;

import de.steamwar.bausystem.Permission;
import de.steamwar.bausystem.region.Region;
import de.steamwar.bausystem.region.RegionUtils;
import de.steamwar.bausystem.region.flags.Flag;
import de.steamwar.bausystem.region.flags.flagvalues.FreezeMode;
import de.steamwar.command.SWCommand;
import de.steamwar.command.TypeValidator;
import de.steamwar.linkage.Linked;
import org.bukkit.entity.Player;

@Linked
public class FreezeCommand extends SWCommand {

    public FreezeCommand() {
        super("freeze", "stoplag", "sl");
    }

    @Register(description = "REGION_FREEZE_HELP")
    public void toggleCommand(@Validator Player p) {
        Region region = Region.getRegion(p.getLocation());
        if (toggle(region)) {
            RegionUtils.actionBar(region, getEnableMessage());
        } else {
            RegionUtils.actionBar(region, getDisableMessage());
        }
    }

    private String getEnableMessage(){
        return "REGION_FREEZE_ENABLED";
    }

    private String getDisableMessage(){
        return "REGION_FREEZE_DISABLED";
    }

    private boolean toggle(Region region) {
        switch (region.getPlain(Flag.FREEZE, FreezeMode.class)) {
            case ACTIVE:
                region.set(Flag.FREEZE, FreezeMode.INACTIVE);
                return false;
            default:
            case INACTIVE:
                region.set(Flag.FREEZE, FreezeMode.ACTIVE);
                return true;
        }
    }
}
